# -*- coding: utf8 -*-
import os
import sys
import re
import cStringIO

templateFolder = ''
def setTemplateFolder(path):
	global templateFolder
	templateFolder = path
def getTemplate(fileName):
	global templateFolder
	return file(os.path.join(templateFolder, fileName), 'rb').read()

pat = re.compile('<:(.+?):>', re.DOTALL)
def templateProcessor(template, globalNS={}, localNS={}):
	global pat
	def repl(match):
		code = match.group(1).strip()
		if code.startswith('#statements'):
			buf = cStringIO.StringIO()
			stdout = sys.stdout
			sys.stdout = buf
			exec code in globalNS, localNS
			sys.stdout = stdout
			return buf.getvalue()
		elif code.startswith('#include'):
			fileName = code.split()[1]
			return templateProcessor(getTemplate(fileName), globalNS, localNS)
		return str(eval(code, globalNS, localNS))
	s = pat.sub(repl, template)
	return s
