# -*- coding: utf8 -*-

import urllib
import cgi

import Request

def encode(pageName):
	return urllib.quote(pageName).replace('%', '_')

def decode(encPageName):
	return urllib.unquote(encPageName.replace('_', '%'))

escape = cgi.escape
quote = urllib.quote

def nl2br(text):
	return text.replace('\n', '<br />')

def joinPath(*args):
	args = filter(None, args)
	return '/'.join(args)

def makeLink(categoryPath, pageName='', klass='', linkName=''):
	request = Request.Request()
	pagePath = joinPath(categoryPath, pageName)
	linkPath = request.scriptName +'/'+ encode(pagePath)
	klass = klass and ' class="%s"' % klass or '' 
	return '<a%s href="%s">%s</a>' % (klass, linkPath, linkName or pagePath)


def diff(old, new): 
	import difflib
	ret = []
	L = list(difflib.ndiff(old.splitlines(), new.splitlines()))
	ret = [] # FIXME  테그 교체할 것
	for line in L:
		if line[0] == '+':
			ret.append('<span class="diffPlus"><ins>%s</ins></span>' % line[2:])
		elif line[0] == '-':
			ret.append('<span class="diffMinus"><del>%s</del></span>' % line[2:])
		elif line[0] == ' ':
			ret.append('%s' % line[2:])
	return '\n'.join(ret) # FIXME 이거랑..< 이런것들  엔터티로 처리


