# -*- coding: utf8 -*-
import os
import Repository

editLogFile = 'edit.log' 

def log(logFileName, *args):
	logPath = os.path.join(Repository.getLogRepository(), logFileName) 
	file(logPath, 'ab').write('\t'.join(map(str, args))+'\n')

def editLog(*args):
	log(editLogFile, *args)

def getRawLines(logFileName, size=6000):
	logPath = os.path.join(Repository.getLogRepository(), logFileName) 
	if not os.path.isfile(logPath):
		return []
	fileSize = os.path.getsize(logPath)
	f = file(logPath, 'rb')
	if fileSize > size:
		f.seek(-size, 2) # 2 : seek releative to the file's end
		f.readline() # dummy
	lines = f.readlines()
	f.close()
	return lines

def getEditLogRawLines(size=6000):
	return getRawLines(editLogFile, size)

