# -*- coding: utf8 -*-
import templateProcessor

class Response:
	def __init__(self, templateName=None, globalNS={}, localNS={}):
		self.setTemplate(templateName)
		self.setNameSpace(globalNS, localNS)
		self.setContentType('text/html')

	def setContents(self, contents):
		self.contents = contents

	def setTemplate(self, templateName):
		self.templateName = templateName
		if self.templateName:
			self.template = templateProcessor.getTemplate(self.templateName) # FIXME setTemplate으로 옮겨야하나?
	def setNameSpace(self, globalNS, localNS): 
		self.globalNS = globalNS
		self.localNS = localNS
	def setContentType(self, _type):
		self.contentType = _type
	def __repr__(self):
		print 'Content-Type: %s\n' % self.contentType
		if self.templateName:
			if not self.localNS.get('title') and self.localNS.get('request'):
				self.localNS['title'] = self.localNS['request'].pageName 
			if not self.localNS.get('msg'):
				self.localNS['msg'] = self.localNS['request'].msg
			return templateProcessor.templateProcessor(self.template, self.globalNS, self.localNS)
		return self.contents
		

